from db_connet import *
from tool import *


# 構件商品比對
def compare_key(prod_component, key):
    return key in prod_component.keys()

# 構件商品
sql = f"""
        SELECT 
            spec.code,mapp.prod_component_id,mapp.quantity,com.topic
        FROM 
            `mapping_spec_component` mapp 
        LEFT JOIN `prod_component` com on mapp.prod_component_id = com.id 
        LEFT JOIN products_general_spec spec on spec.id = mapp.prod_spec_id
    """
data = select_db(sql,'docker-june1')
prod_component = {}
prod_name = {}
for item in data:
    prod_name[item['prod_component_id']]=item['topic']
    code = item['code']
    if code not in prod_component:
        prod_component[code] = {}
    id = item['prod_component_id']
    if id not in prod_component[code]:
        prod_component[code][id] = []
    prod_component[code][id].append(item['quantity'])

# 撈出訂單資料
sql = f"""
    SELECT 
        a.id, a.ordernumber,d.amount,d.product_code as code,d.invoice_name
    FROM 
        `order_detail` d
        LEFT JOIN `order_list` a  ON a.ordernumber = d.ordernumber 
    WHERE a.id > 0 
        AND d.item_status = '1' 
        AND a.status = 1 
        AND a.process_status != '6' 
        AND 
            (a.etd BETWEEN '2023-05-18 00:00:00' and '2023-05-18 00:00:00' 
            || d.etd BETWEEN '2023-05-18 00:00:00' and '2023-05-18 00:00:00')
    """
res = select_db(sql,'docker-june1')
mydict = create_dict()

# 整理核對訂單明細資料
for key,val in enumerate(res):
    mydict.add(key,
                ({
                    "amount" : val['amount'],
                    "code" : val['code'],
                    'invoice_name' : val['invoice_name']
                })
            )
# 塞入核對的構建商品資料
for val in mydict:
    mydict[key]['component'] = ''
    if compare_key(prod_component,mydict[val]['code']):
        mydict[val]['component'] = (prod_component[mydict[val]['code']])
    else:
        print('找無此構建:('+mydict[val]['code']+')'+mydict[val]['invoice_name'])

# 重組統計
result = {}
for value in mydict.values():
    if 'component' in value:
        amount = value['amount']
        component = value['component']
        if hasattr(component,"items"):
            for key, sub_value in component.items():
                quantity = len(sub_value)
                if key in result:
                    result[key] += amount * quantity
                else:
                    result[key] = amount * quantity

#  列出結果
for key,val in result.items():
    print(prod_name[key]+":"+str(val))